Color Scale in JavaScript

Using ApexCharts with JavaScript

This Color Scale example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
var options = {
  series: [
    {
      data: [
        {
          x: 'INTC',
          y: 1.2,
        },
        {
          x: 'GS',
          y: 0.4,
        },
        {
          x: 'CVX',
          y: -1.4,
        },
        {
          x: 'GE',
          y: 2.7,
        },
        {
          x: 'CAT',
          y: -0.3,
        },
        {
          x: 'RTX',
          y: 5.1,
        },
        {
          x: 'CSCO',
          y: -2.3,
        },
        {
          x: 'JNJ',
          y: 2.1,
        },
        {
          x: 'PG',
          y: 0.3,
        },
        {
          x: 'TRV',
          y: 0.12,
        },
        {
          x: 'MMM',
          y: -2.31,
        },
        {
          x: 'NKE',
          y: 3.98,
        },
        {
          x: 'IYT',
          y: 1.67,
        },
      ],
    },
  ],
  legend: {
    show: false,
  },
  chart: {
    height: 350,
    type: 'treemap',
  },
  title: {
    text: 'Treemap with Color scale',
  },
  dataLabels: {
    enabled: true,
    style: {
      fontSize: '12px',
    },
    formatter: function (text, op) {
      return [text, op.value]
    },
    offsetY: -4,
  },
  plotOptions: {
    treemap: {
      enableShades: true,
      shadeIntensity: 0.5,
      reverseNegativeShade: true,
      colorScale: {
        ranges: [
          {
            from: -6,
            to: 0,
            color: '#CD363A',
          },
          {
            from: 0.001,
            to: 6,
            color: '#52B12C',
          },
        ],
      },
    },
  },
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

Color Scale in Angular

Using ApexCharts with Angular

This Color Scale example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  public chartOptions: Partial<ChartOptions> = {
          series: [
            {
              data: [
                {
                  x: 'INTC',
                  y: 1.2,
                },
                {
                  x: 'GS',
                  y: 0.4,
                },
                {
                  x: 'CVX',
                  y: -1.4,
                },
                {
                  x: 'GE',
                  y: 2.7,
                },
                {
                  x: 'CAT',
                  y: -0.3,
                },
                {
                  x: 'RTX',
                  y: 5.1,
                },
                {
                  x: 'CSCO',
                  y: -2.3,
                },
                {
                  x: 'JNJ',
                  y: 2.1,
                },
                {
                  x: 'PG',
                  y: 0.3,
                },
                {
                  x: 'TRV',
                  y: 0.12,
                },
                {
                  x: 'MMM',
                  y: -2.31,
                },
                {
                  x: 'NKE',
                  y: 3.98,
                },
                {
                  x: 'IYT',
                  y: 1.67,
                },
              ],
            },
          ],
          legend: {
            show: false,
          },
          chart: {
            height: 350,
            type: 'treemap',
          },
          title: {
            text: 'Treemap with Color scale',
          },
          dataLabels: {
            enabled: true,
            style: {
              fontSize: '12px',
            },
            formatter: (text, op) => {
              return [text, op.value]
            },
            offsetY: -4,
          },
          plotOptions: {
            treemap: {
              enableShades: true,
              shadeIntensity: 0.5,
              reverseNegativeShade: true,
              colorScale: {
                ranges: [
                  {
                    from: -6,
                    to: 0,
                    color: '#CD363A',
                  },
                  {
                    from: 0.001,
                    to: 6,
                    color: '#52B12C',
                  },
                ],
              },
            },
          },
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}

Color Scale in Vue

Using ApexCharts with Vue

This Color Scale example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div id="chart">
      <apexchart
        type="treemap"
        height="350"
        :options="chartOptions"
        :series="series"
      ></apexchart>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'

export default {
  components: {
    apexchart: VueApexCharts,
  },
  data: function () {
    return {
      series: [
        {
          data: [
            {
              x: 'INTC',
              y: 1.2,
            },
            {
              x: 'GS',
              y: 0.4,
            },
            {
              x: 'CVX',
              y: -1.4,
            },
            {
              x: 'GE',
              y: 2.7,
            },
            {
              x: 'CAT',
              y: -0.3,
            },
            {
              x: 'RTX',
              y: 5.1,
            },
            {
              x: 'CSCO',
              y: -2.3,
            },
            {
              x: 'JNJ',
              y: 2.1,
            },
            {
              x: 'PG',
              y: 0.3,
            },
            {
              x: 'TRV',
              y: 0.12,
            },
            {
              x: 'MMM',
              y: -2.31,
            },
            {
              x: 'NKE',
              y: 3.98,
            },
            {
              x: 'IYT',
              y: 1.67,
            },
          ],
        },
      ],
      chartOptions: {
        legend: {
          show: false,
        },
        chart: {
          height: 350,
          type: 'treemap',
        },
        title: {
          text: 'Treemap with Color scale',
        },
        dataLabels: {
          enabled: true,
          style: {
            fontSize: '12px',
          },
          formatter: function (text, op) {
            return [text, op.value]
          },
          offsetY: -4,
        },
        plotOptions: {
          treemap: {
            enableShades: true,
            shadeIntensity: 0.5,
            reverseNegativeShade: true,
            colorScale: {
              ranges: [
                {
                  from: -6,
                  to: 0,
                  color: '#CD363A',
                },
                {
                  from: 0.001,
                  to: 6,
                  color: '#52B12C',
                },
              ],
            },
          },
        },
      },
    }
  },
}
</script>

<style>
#chart {
  max-width: 650px;
  margin: 35px auto;
}
</style>

Color Scale in React

Using ApexCharts with React

This Color Scale example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import './styles.css'

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: [
      {
        data: [
          {
            x: 'INTC',
            y: 1.2,
          },
          {
            x: 'GS',
            y: 0.4,
          },
          {
            x: 'CVX',
            y: -1.4,
          },
          {
            x: 'GE',
            y: 2.7,
          },
          {
            x: 'CAT',
            y: -0.3,
          },
          {
            x: 'RTX',
            y: 5.1,
          },
          {
            x: 'CSCO',
            y: -2.3,
          },
          {
            x: 'JNJ',
            y: 2.1,
          },
          {
            x: 'PG',
            y: 0.3,
          },
          {
            x: 'TRV',
            y: 0.12,
          },
          {
            x: 'MMM',
            y: -2.31,
          },
          {
            x: 'NKE',
            y: 3.98,
          },
          {
            x: 'IYT',
            y: 1.67,
          },
        ],
      },
    ],
    options: {
      legend: {
        show: false,
      },
      chart: {
        height: 350,
        type: 'treemap',
      },
      title: {
        text: 'Treemap with Color scale',
      },
      dataLabels: {
        enabled: true,
        style: {
          fontSize: '12px',
        },
        formatter: function (text, op) {
          return [text, op.value]
        },
        offsetY: -4,
      },
      plotOptions: {
        treemap: {
          enableShades: true,
          shadeIntensity: 0.5,
          reverseNegativeShade: true,
          colorScale: {
            ranges: [
              {
                from: -6,
                to: 0,
                color: '#CD363A',
              },
              {
                from: 0.001,
                to: 6,
                color: '#52B12C',
              },
            ],
          },
        },
      },
    },
  })

  return (
    <div>
      <div id="chart">
        <ReactApexChart
          options={state.options}
          series={state.series}
          type="treemap"
          height={350}
        />
      </div>
    </div>
  )
}

export default ApexChart